local FC = ...

require("os")

local hp = os.getenv("HOMEPATH")
local mp = hp .. "\\Documents\\Polymorph Games\\Foundation\\mods\\500\\"
local cp = hp .. "\\Documents\\Polymorph Games\\Foundation\\mods\\Fiery Essential\\"


local f, err = io.open(cp .. "balancing config\\creative\\balance.json","r")
if err then os.execute("mkdir " .. "\"" .. cp .. "balancing config\\creative".."\"")else f = nil end
err = nil

local f, err = io.open(cp .. "balancing config\\default\\balance.json","r")
if err then os.execute("mkdir " .. "\"" .. cp .. "balancing config\\default".."\"")else f = nil end
err = nil

local f, err = io.open(cp .. "balancing config\\custom\\balance.json","r")
if err then os.execute("mkdir " .. "\"" .. cp .. "balancing config\\custom".."\"")else f = nil end
err = nil

package.path = mp .. "dkjson.lua"

local status, json  = pcall(require, "dkjson")
if status then
	package.path = mp .. "dkjson.lua"
	json = require ("dkjson")
else
	package.path = "mods\\500\\dkjson.lua"
	json = require ("dkjson")
end
status = nill

local jstr = ""
local FCtemplates = {["main"] = {},["default"] = {},["creative"] = {},["default"] = {},["custom"] = {}}

local f,err = io.open(cp .. "mainConfig.json","r")
if err then
	err = nil
	FCtemplates["main"]["config version"] = "0.2"
	FCtemplates["main"]["balance mode"] = "creative"
	FCtemplates["main"]["more villager names"] = true
	FCtemplates["main"]["enable welcome event"] = true 

	local f,err = io.open(cp .. "mainConfig.json","wb")
	jstr = json.encode (FCtemplates["main"], { indent = true })
	f:write(jstr)
	f:close()
	f = nil
	err = nil
else f = nil end



local f, err = io.open(cp .. "balancing config\\creative\\balance.json","r")
if err then
	err = nil
	FCtemplates["creative"]["day duration"] = 60
	FCtemplates["creative"]["starting families"] = 10
	FCtemplates["creative"]["leave if happiness below"] = -99999
--	FCtemplates["creative"]["VillagerStatusQuota"] = "VILLAGER_STATUS_QUOTA_DEFAULT"
	FCtemplates["creative"]["territory price"] = {{Resource = "GOLD",Quantity = 0}}
	FCtemplates["creative"]["territory taxes"] = {{{Resource = "GOLD",Quantity = 0}},{{Resource = "GOLD",Quantity = 0}},{{Resource = "GOLD",Quantity = 0}},{{Resource = "GOLD",Quantity = 0}}}
	FCtemplates["creative"]["starting tile requirement"] = {{Resource = "BERRIES", Quantity = 0},{Resource = "STONE", Quantity = 0}}
	FCtemplates["creative"]["days between events"] = 30
	FCtemplates["creative"]["days to first event"] = 15
	FCtemplates["creative"]["gold capacity"] = 1000000
	FCtemplates["creative"]["tree grow speed"] = 0.001
	FCtemplates["creative"]["initial tree size"] = 1
	FCtemplates["creative"]["minimum tree size to gather"] = 0.75
	FCtemplates["creative"]["minimum tree size to hunt"] = 0.75
	FCtemplates["creative"]["fertility impact by tree hard radius"] = 0
	FCtemplates["creative"]["fertility impact by tree soft radius"] = 0
	FCtemplates["creative"]["fertility impact by tree"] = 0
--	FCtemplates["creative"]["DelayedQuestList"] = {{QuestResource = "INFLUENCE_QUEST", Delay = 0}} 

	local f,err = io.open(cp .. "balancing config\\creative\\balance.json","wb")
	jstr = json.encode (FCtemplates["creative"], { indent = true }) 
	f:write(jstr)
	f:close()
	f = nil
	err = nil
else f = nil end



local f, err = io.open(cp .. "balancing config\\default\\balance.json","r")
f=nil
local f, erro = io.open(cp .. "balancing config\\custom\\balance.json","r")
f = nil
if err or erro then

	FCtemplates["default"]["day duration"] = 60
	FCtemplates["default"]["starting families"] = 4
	FCtemplates["default"]["leave if happiness below"] = -30
--	FCtemplates["default"]["VillagerStatusQuota"] = "VILLAGER_STATUS_QUOTA_DEFAULT"
	FCtemplates["default"]["territory price"] = {{Resource = "GOLD",Quantity = 500}}
	FCtemplates["default"]["territory taxes"] = {{{Resource = "GOLD",Quantity = 0}},{{Resource = "GOLD",Quantity = 10}},{{Resource = "GOLD",Quantity = 25}},{{Resource = "GOLD",Quantity = 50}}}
	FCtemplates["default"]["starting tile requirement"] = {{Resource = "BERRIES", Quantity = 1},{Resource = "STONE", Quantity = 1}}
	FCtemplates["default"]["days between events"] = 30
	FCtemplates["default"]["days to first event"] = 15
	FCtemplates["default"]["gold capacity"] = 500
	FCtemplates["default"]["tree grow speed"] = 0.001
	FCtemplates["default"]["initial tree size"] = 0.1
	FCtemplates["default"]["minimum tree size to gather"] = 0.75
	FCtemplates["default"]["minimum tree size to hunt"] = 0.75
	FCtemplates["default"]["fertility impact by tree hard radius"] = 3.5
	FCtemplates["default"]["fertility impact by tree soft radius"] = 15
	FCtemplates["default"]["fertility impact by tree"] = 0.01
--	FCtemplates["default"]["DelayedQuestList"] = {{QuestResource = "INFLUENCE_QUEST", Delay = 0}}

	if err then
		err = nil
		local f,err = io.open(cp .. "balancing config\\default\\balance.json","wb")
		jstr = json.encode (FCtemplates["default"], { indent = true }) 
		f:write(jstr)
		f:close()
		err = nil
		f = nil
	end
	if erro then
		erro = nil
		local f,err = io.open(cp .. "balancing config\\custom\\balance.json","wb")
		jstr = json.encode (FCtemplates["default"], { indent = true }) 
		f:write(jstr)
		f:close()
		err = nil
		f = nil
	end
end



local f, err = io.open(cp .. "balancing config\\creative\\buildingCosts.json","r")
if err then
	err = nil
	FCtemplates["creative costs"] = {}
	FCtemplates["creative costs"]["lumber camp"] = {}
	FCtemplates["creative costs"]["lumber camp"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["lumber camp"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["lumber camp"]["building"] = {{Resource = "TOOL", Quantity = 0}}	
	FCtemplates["creative costs"]["stonecutter camp"] = {}
	FCtemplates["creative costs"]["stonecutter camp"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["stonecutter camp"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["stonecutter camp"]["building"] = {{Resource = "WOOD", Quantity = 0},{Resource = "TOOL", Quantity = 0}}
	FCtemplates["creative costs"]["gathering hut"] = {}
	FCtemplates["creative costs"]["gathering hut"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["gathering hut"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["gathering hut"]["building"] = {{Resource = "WOOD", Quantity = 0}}
	FCtemplates["creative costs"]["well"] = {}
	FCtemplates["creative costs"]["well"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["well"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["well"]["building"] = {{Resource = "WOOD", Quantity = 0},{Resource = "STONE", Quantity = 0}}
	FCtemplates["creative costs"]["sawmill"] = {}
	FCtemplates["creative costs"]["sawmill"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["sawmill"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["sawmill"]["building"] = {{Resource = "WOOD", Quantity = 0},{Resource = "STONE", Quantity = 0}}
	FCtemplates["creative costs"]["warehouse"] = {}
	FCtemplates["creative costs"]["warehouse"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["warehouse"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["warehouse"]["building"] = {{Resource = "PLANK", Quantity = 0},{Resource = "STONE", Quantity = 0}}
	FCtemplates["creative costs"]["fisher's hut"] = {}
	FCtemplates["creative costs"]["fisher's hut"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["fisher's hut"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["fisher's hut"]["building"] = {{Resource = "WOOD", Quantity = 0}}
	FCtemplates["creative costs"]["forester camp"] = {}
	FCtemplates["creative costs"]["forester camp"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["forester camp"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["forester camp"]["building"] = {{Resource = "PLANK", Quantity = 0}}
	FCtemplates["creative costs"]["stonemason hut"] = {}
	FCtemplates["creative costs"]["stonemason hut"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["stonemason hut"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["stonemason hut"]["building"] = {{Resource = "WOOD", Quantity = 0},{Resource = "WOOLEN_CLOTH", Quantity = 0}}
	FCtemplates["creative costs"]["houselvl1"] = {}
	FCtemplates["creative costs"]["houselvl1"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["houselvl1"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["houselvl1"]["building"] = {{Resource = "WOOD", Quantity = 0}}
	FCtemplates["creative costs"]["sheep farm"] = {}
	FCtemplates["creative costs"]["sheep farm"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["sheep farm"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["sheep farm"]["building"] = {{Resource = "WOOD", Quantity = 0},{Resource = "STONE", Quantity = 0},{Resource = "TOOL", Quantity = 0}}
	FCtemplates["creative costs"]["weaver hut"] = {}
	FCtemplates["creative costs"]["weaver hut"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["weaver hut"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["weaver hut"]["building"] = {{Resource = "STONE", Quantity = 0},{Resource = "TOOL", Quantity = 0},{Resource = "PLANK", Quantity = 0}}
	FCtemplates["creative costs"]["tailor's workshop"] = {}
	FCtemplates["creative costs"]["tailor's workshop"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["tailor's workshop"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["tailor's workshop"]["building"] = {{Resource = "PLANK", Quantity = 0},{Resource = "POLISHED_STONE", Quantity = 0},{Resource = "TOOL", Quantity = 0}}
	FCtemplates["creative costs"]["wheat farm"] = {}
	FCtemplates["creative costs"]["wheat farm"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["wheat farm"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["wheat farm"]["building"] = {{Resource = "PLANK", Quantity = 0},{Resource = "TOOL", Quantity = 0}}
	FCtemplates["creative costs"]["windmill"] = {}
	FCtemplates["creative costs"]["windmill"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["windmill"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["windmill"]["building"] = {{Resource = "STONE", Quantity = 0},{Resource = "PLANK", Quantity = 0},{Resource = "TOOL", Quantity = 0}}
	FCtemplates["creative costs"]["bakery"] = {}
	FCtemplates["creative costs"]["bakery"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["bakery"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["bakery"]["building"] = {{Resource = "STONE", Quantity = 0},{Resource = "PLANK", Quantity = 0},{Resource = "TOOL", Quantity = 0}}
	FCtemplates["creative costs"]["iron mine"] = {}
	FCtemplates["creative costs"]["iron mine"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["iron mine"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["iron mine"]["building"] = {{Resource = "PLANK", Quantity = 0},{Resource = "TOOL", Quantity = 0}}
	FCtemplates["creative costs"]["iron smelter"] = {}
	FCtemplates["creative costs"]["iron smelter"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["iron smelter"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["iron smelter"]["building"] = {{Resource = "PLANK", Quantity = 0},{Resource = "STONE", Quantity = 0},{Resource = "TOOL", Quantity = 0}}
	FCtemplates["creative costs"]["blacksmith"] = {}
	FCtemplates["creative costs"]["blacksmith"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["blacksmith"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["blacksmith"]["building"] = {{Resource = "PLANK", Quantity = 0},{Resource = "STONE", Quantity = 0},{Resource = "TOOL", Quantity = 0}}
	FCtemplates["creative costs"]["coal hut"] = {}
	FCtemplates["creative costs"]["coal hut"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["coal hut"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["coal hut"]["building"] = {{Resource = "WOOD", Quantity = 0},{Resource = "TOOL", Quantity = 0}}
	FCtemplates["creative costs"]["food stall"] = {}
	FCtemplates["creative costs"]["food stall"]["upfront"] = {}
	FCtemplates["creative costs"]["food stall"]["maintenance"] = {}
	FCtemplates["creative costs"]["food stall"]["building"] = {{Resource = "WOOD", Quantity = 0}}
	FCtemplates["creative costs"]["goods stall"] = {}
	FCtemplates["creative costs"]["goods stall"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["goods stall"]["maintenance"] = {}
	FCtemplates["creative costs"]["goods stall"]["building"] = {{Resource = "WOOD", Quantity = 0}}
	FCtemplates["creative costs"]["luxury goods stall"] = {}
	FCtemplates["creative costs"]["luxury goods stall"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["luxury goods stall"]["maintenance"] = {}
	FCtemplates["creative costs"]["luxury goods stall"]["building"] = {{Resource = "WOOD", Quantity = 0}}
	FCtemplates["creative costs"]["decorative bush"] = {}
	FCtemplates["creative costs"]["decorative bush"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["decorative bush"]["maintenance"] = {}
	FCtemplates["creative costs"]["decorative bush"]["building"] = {}
	FCtemplates["creative costs"]["cypress"] = {}
	FCtemplates["creative costs"]["cypress"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["cypress"]["maintenance"] = {}
	FCtemplates["creative costs"]["cypress"]["building"] = {}
	FCtemplates["creative costs"]["decorative tree"] = {}
	FCtemplates["creative costs"]["decorative tree"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["decorative tree"]["maintenance"] = {}
	FCtemplates["creative costs"]["decorative tree"]["building"] = {}
	FCtemplates["creative costs"]["fence"] = {}
	FCtemplates["creative costs"]["fence"]["upfront"] = {{Resource = "GOLD", Quantity = 0},{Resource = "TOOL", Quantity = 0},{Resource = "PLANK", Quantity = 0}}
	FCtemplates["creative costs"]["fence"]["maintenance"] = {}
	FCtemplates["creative costs"]["fence"]["building"] = {}
	FCtemplates["creative costs"]["fountain"] = {}
	FCtemplates["creative costs"]["fountain"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["creative costs"]["fountain"]["maintenance"] = {}
	FCtemplates["creative costs"]["fountain"]["building"] = {{Resource = "TOOL", Quantity = 0},{Resource = "POLISHED_STONE", Quantity = 0}}
	FCtemplates["creative costs"]["wooden gate"] = {}
	FCtemplates["creative costs"]["wooden gate"]["upfront"] = {}
	FCtemplates["creative costs"]["wooden gate"]["maintenance"] = {}
	FCtemplates["creative costs"]["wooden gate"]["building"] = {}

	local f,err = io.open(cp .. "balancing config\\creative\\buildingCosts.json","wb")
	jstr = json.encode (FCtemplates["creative costs"], { indent = true }) 
	f:write(jstr)
	f:close()
	err = nil
	f = nil
else f = nil end


local f, erro = io.open(cp .. "balancing config\\custom\\buildingCosts.json","r")
f=nil
local f, err = io.open(cp .. "balancing config\\default\\buildingCosts.json","r")
f = nil
if err or erro then

	FCtemplates["default costs"] = {}
	FCtemplates["default costs"]["lumber camp"] = {}
	FCtemplates["default costs"]["lumber camp"]["upfront"] = {{Resource = "GOLD", Quantity = 20}}
	FCtemplates["default costs"]["lumber camp"]["maintenance"] = {{Resource = "GOLD", Quantity = 1}}
	FCtemplates["default costs"]["lumber camp"]["building"] = {{Resource = "TOOL", Quantity = 5}}	
	FCtemplates["default costs"]["stonecutter camp"] = {}
	FCtemplates["default costs"]["stonecutter camp"]["upfront"] = {{Resource = "GOLD", Quantity = 25}}
	FCtemplates["default costs"]["stonecutter camp"]["maintenance"] = {{Resource = "GOLD", Quantity = 1}}
	FCtemplates["default costs"]["stonecutter camp"]["building"] = {{Resource = "WOOD", Quantity = 10},{Resource = "TOOL", Quantity = 5}}
	FCtemplates["default costs"]["gathering hut"] = {}
	FCtemplates["default costs"]["gathering hut"]["upfront"] = {{Resource = "GOLD", Quantity = 20}}
	FCtemplates["default costs"]["gathering hut"]["maintenance"] = {{Resource = "GOLD", Quantity = 1}}
	FCtemplates["default costs"]["gathering hut"]["building"] = {{Resource = "WOOD", Quantity = 10}}
	FCtemplates["default costs"]["well"] = {}
	FCtemplates["default costs"]["well"]["upfront"] = {{Resource = "GOLD", Quantity = 20}}
	FCtemplates["default costs"]["well"]["maintenance"] = {{Resource = "GOLD", Quantity = 1}}
	FCtemplates["default costs"]["well"]["building"] = {{Resource = "WOOD", Quantity = 10},{Resource = "STONE", Quantity = 5}}
	FCtemplates["default costs"]["sawmill"] = {}
	FCtemplates["default costs"]["sawmill"]["upfront"] = {{Resource = "GOLD", Quantity = 100}}
	FCtemplates["default costs"]["sawmill"]["maintenance"] = {{Resource = "GOLD", Quantity = 2}}
	FCtemplates["default costs"]["sawmill"]["building"] = {{Resource = "WOOD", Quantity = 20},{Resource = "STONE", Quantity = 10}}
	FCtemplates["default costs"]["warehouse"] = {}
	FCtemplates["default costs"]["warehouse"]["upfront"] = {{Resource = "GOLD", Quantity = 50}}
	FCtemplates["default costs"]["warehouse"]["maintenance"] = {{Resource = "GOLD", Quantity = 5}}
	FCtemplates["default costs"]["warehouse"]["building"] = {{Resource = "PLANK", Quantity = 15},{Resource = "STONE", Quantity = 5}}
	FCtemplates["default costs"]["fisher's hut"] = {}
	FCtemplates["default costs"]["fisher's hut"]["upfront"] = {{Resource = "GOLD", Quantity = 20}}
	FCtemplates["default costs"]["fisher's hut"]["maintenance"] = {{Resource = "GOLD", Quantity = 2}}
	FCtemplates["default costs"]["fisher's hut"]["building"] = {{Resource = "WOOD", Quantity = 20}}
	FCtemplates["default costs"]["forester camp"] = {}
	FCtemplates["default costs"]["forester camp"]["upfront"] = {{Resource = "GOLD", Quantity = 50}}
	FCtemplates["default costs"]["forester camp"]["maintenance"] = {{Resource = "GOLD", Quantity = 10}}
	FCtemplates["default costs"]["forester camp"]["building"] = {{Resource = "PLANK", Quantity = 10}}
	FCtemplates["default costs"]["stonemason hut"] = {}
	FCtemplates["default costs"]["stonemason hut"]["upfront"] = {{Resource = "GOLD", Quantity = 25}}
	FCtemplates["default costs"]["stonemason hut"]["maintenance"] = {{Resource = "GOLD", Quantity = 1}}
	FCtemplates["default costs"]["stonemason hut"]["building"] = {{Resource = "WOOD", Quantity = 10},{Resource = "WOOLEN_CLOTH", Quantity = 5}}
	FCtemplates["default costs"]["houselvl1"] = {}
	FCtemplates["default costs"]["houselvl1"]["upfront"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["default costs"]["houselvl1"]["maintenance"] = {{Resource = "GOLD", Quantity = 0}}
	FCtemplates["default costs"]["houselvl1"]["building"] = {{Resource = "WOOD", Quantity = 10}}
	FCtemplates["default costs"]["sheep farm"] = {}
	FCtemplates["default costs"]["sheep farm"]["upfront"] = {{Resource = "GOLD", Quantity = 50}}
	FCtemplates["default costs"]["sheep farm"]["maintenance"] = {{Resource = "GOLD", Quantity = 2}}
	FCtemplates["default costs"]["sheep farm"]["building"] = {{Resource = "WOOD", Quantity = 10},{Resource = "STONE", Quantity = 10},{Resource = "TOOL", Quantity = 5}}
	FCtemplates["default costs"]["weaver hut"] = {}
	FCtemplates["default costs"]["weaver hut"]["upfront"] = {{Resource = "GOLD", Quantity = 100}}
	FCtemplates["default costs"]["weaver hut"]["maintenance"] = {{Resource = "GOLD", Quantity = 2}}
	FCtemplates["default costs"]["weaver hut"]["building"] = {{Resource = "STONE", Quantity = 10},{Resource = "TOOL", Quantity = 5},{Resource = "PLANK", Quantity = 10}}
	FCtemplates["default costs"]["tailor's workshop"] = {}
	FCtemplates["default costs"]["tailor's workshop"]["upfront"] = {{Resource = "GOLD", Quantity = 50}}
	FCtemplates["default costs"]["tailor's workshop"]["maintenance"] = {{Resource = "GOLD", Quantity = 1}}
	FCtemplates["default costs"]["tailor's workshop"]["building"] = {{Resource = "PLANK", Quantity = 5},{Resource = "POLISHED_STONE", Quantity = 5},{Resource = "TOOL", Quantity = 2}}
	FCtemplates["default costs"]["wheat farm"] = {}
	FCtemplates["default costs"]["wheat farm"]["upfront"] = {{Resource = "GOLD", Quantity = 100}}
	FCtemplates["default costs"]["wheat farm"]["maintenance"] = {{Resource = "GOLD", Quantity = 2}}
	FCtemplates["default costs"]["wheat farm"]["building"] = {{Resource = "PLANK", Quantity = 20},{Resource = "TOOL", Quantity = 10}}
	FCtemplates["default costs"]["windmill"] = {}
	FCtemplates["default costs"]["windmill"]["upfront"] = {{Resource = "GOLD", Quantity = 200}}
	FCtemplates["default costs"]["windmill"]["maintenance"] = {{Resource = "GOLD", Quantity = 2}}
	FCtemplates["default costs"]["windmill"]["building"] = {{Resource = "STONE", Quantity = 10},{Resource = "PLANK", Quantity = 10},{Resource = "TOOL", Quantity = 10}}
	FCtemplates["default costs"]["bakery"] = {}
	FCtemplates["default costs"]["bakery"]["upfront"] = {{Resource = "GOLD", Quantity = 300}}
	FCtemplates["default costs"]["bakery"]["maintenance"] = {{Resource = "GOLD", Quantity = 3}}
	FCtemplates["default costs"]["bakery"]["building"] = {{Resource = "STONE", Quantity = 20},{Resource = "PLANK", Quantity = 20},{Resource = "TOOL", Quantity = 20}}
	FCtemplates["default costs"]["iron mine"] = {}
	FCtemplates["default costs"]["iron mine"]["upfront"] = {{Resource = "GOLD", Quantity = 100}}
	FCtemplates["default costs"]["iron mine"]["maintenance"] = {{Resource = "GOLD", Quantity = 5}}
	FCtemplates["default costs"]["iron mine"]["building"] = {{Resource = "PLANK", Quantity = 20},{Resource = "TOOL", Quantity = 10}}
	FCtemplates["default costs"]["iron smelter"] = {}
	FCtemplates["default costs"]["iron smelter"]["upfront"] = {{Resource = "GOLD", Quantity = 150}}
	FCtemplates["default costs"]["iron smelter"]["maintenance"] = {{Resource = "GOLD", Quantity = 2}}
	FCtemplates["default costs"]["iron smelter"]["building"] = {{Resource = "PLANK", Quantity = 20},{Resource = "STONE", Quantity = 10},{Resource = "TOOL", Quantity = 10}}
	FCtemplates["default costs"]["blacksmith"] = {}
	FCtemplates["default costs"]["blacksmith"]["upfront"] = {{Resource = "GOLD", Quantity = 200}}
	FCtemplates["default costs"]["blacksmith"]["maintenance"] = {{Resource = "GOLD", Quantity = 5}}
	FCtemplates["default costs"]["blacksmith"]["building"] = {{Resource = "PLANK", Quantity = 20},{Resource = "STONE", Quantity = 20},{Resource = "TOOL", Quantity = 20}}
	FCtemplates["default costs"]["coal hut"] = {}
	FCtemplates["default costs"]["coal hut"]["upfront"] = {{Resource = "GOLD", Quantity = 100}}
	FCtemplates["default costs"]["coal hut"]["maintenance"] = {{Resource = "GOLD", Quantity = 5}}
	FCtemplates["default costs"]["coal hut"]["building"] = {{Resource = "WOOD", Quantity = 20},{Resource = "TOOL", Quantity = 10}}
	FCtemplates["default costs"]["food stall"] = {}
	FCtemplates["default costs"]["food stall"]["upfront"] = {}
	FCtemplates["default costs"]["food stall"]["maintenance"] = {}
	FCtemplates["default costs"]["food stall"]["building"] = {{Resource = "WOOD", Quantity = 10}}
	FCtemplates["default costs"]["goods stall"] = {}
	FCtemplates["default costs"]["goods stall"]["upfront"] = {{Resource = "GOLD", Quantity = 50}}
	FCtemplates["default costs"]["goods stall"]["maintenance"] = {}
	FCtemplates["default costs"]["goods stall"]["building"] = {{Resource = "WOOD", Quantity = 10}}
	FCtemplates["default costs"]["luxury goods stall"] = {}
	FCtemplates["default costs"]["luxury goods stall"]["upfront"] = {{Resource = "GOLD", Quantity = 150}}
	FCtemplates["default costs"]["luxury goods stall"]["maintenance"] = {}
	FCtemplates["default costs"]["luxury goods stall"]["building"] = {{Resource = "WOOD", Quantity = 10}}
	FCtemplates["default costs"]["decorative bush"] = {}
	FCtemplates["default costs"]["decorative bush"]["upfront"] = {{Resource = "GOLD", Quantity = 2}}
	FCtemplates["default costs"]["decorative bush"]["maintenance"] = {}
	FCtemplates["default costs"]["decorative bush"]["building"] = {}
	FCtemplates["default costs"]["cypress"] = {}
	FCtemplates["default costs"]["cypress"]["upfront"] = {{Resource = "GOLD", Quantity = 10}}
	FCtemplates["default costs"]["cypress"]["maintenance"] = {}
	FCtemplates["default costs"]["cypress"]["building"] = {}
	FCtemplates["default costs"]["decorative tree"] = {}
	FCtemplates["default costs"]["decorative tree"]["upfront"] = {{Resource = "GOLD", Quantity = 5}}
	FCtemplates["default costs"]["decorative tree"]["maintenance"] = {}
	FCtemplates["default costs"]["decorative tree"]["building"] = {}
	FCtemplates["default costs"]["fence"] = {}
	FCtemplates["default costs"]["fence"]["upfront"] = {{Resource = "GOLD", Quantity = 5},{Resource = "TOOL", Quantity = 1},{Resource = "PLANK", Quantity = 1}}
	FCtemplates["default costs"]["fence"]["maintenance"] = {}
	FCtemplates["default costs"]["fence"]["building"] = {}
	FCtemplates["default costs"]["fountain"] = {}
	FCtemplates["default costs"]["fountain"]["upfront"] = {{Resource = "GOLD", Quantity = 500}}
	FCtemplates["default costs"]["fountain"]["maintenance"] = {}
	FCtemplates["default costs"]["fountain"]["building"] = {{Resource = "TOOL", Quantity = 20},{Resource = "POLISHED_STONE", Quantity = 50}}
	FCtemplates["default costs"]["wooden gate"] = {}
	FCtemplates["default costs"]["wooden gate"]["upfront"] = {}
	FCtemplates["default costs"]["wooden gate"]["maintenance"] = {}
	FCtemplates["default costs"]["wooden gate"]["building"] = {}

	if err then
		err = nil
		local f,err = io.open(cp .. "balancing config\\default\\buildingCosts.json","wb")
		jstr = json.encode (FCtemplates["default costs"], { indent = true }) 
		f:write(jstr)
		f:close()
		err = nil
		f = nil
	end
	if erro then
		erro = nil
		local f,erro = io.open(cp .. "balancing config\\custom\\buildingCosts.json","wb")
		jstr = json.encode (FCtemplates["default costs"], { indent = true }) 
		f:write(jstr)
		f:close()
		err = nil
		f = nil
	end

end



local f, err = io.open(cp .. "balancing config\\creative\\unlockProgress.json","r")
if err then
	err = nil
	FCtemplates["creative progress"] = {}
	FCtemplates["creative progress"]["lumber camp"] ={}
	FCtemplates["creative progress"]["lumber camp"]["manual unlock"] = false
	FCtemplates["creative progress"]["lumber camp"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["gathering hut"] = {}
	FCtemplates["creative progress"]["gathering hut"]["manual unlock"] = false
	FCtemplates["creative progress"]["gathering hut"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["stonecutter camp"] = {}
	FCtemplates["creative progress"]["stonecutter camp"]["manual unlock"] = false
	FCtemplates["creative progress"]["stonecutter camp"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["sawmill"] = {}
	FCtemplates["creative progress"]["sawmill"]["manual unlock"] = false
	FCtemplates["creative progress"]["sawmill"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["warehouse"] ={}
	FCtemplates["creative progress"]["warehouse"]["manual unlock"] = false
	FCtemplates["creative progress"]["warehouse"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["fisher's hut"] = {}
	FCtemplates["creative progress"]["fisher's hut"]["manual unlock"] = false
	FCtemplates["creative progress"]["fisher's hut"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["hunter's hut"] = {}
	FCtemplates["creative progress"]["hunter's hut"]["manual unlock"] = false
	FCtemplates["creative progress"]["hunter's hut"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["stonemason hut"] = {}
	FCtemplates["creative progress"]["stonemason hut"]["manual unlock"] = false
	FCtemplates["creative progress"]["stonemason hut"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["forester camp"] = {}
	FCtemplates["creative progress"]["forester camp"]["manual unlock"] = false
	FCtemplates["creative progress"]["forester camp"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["wheat farm"] = {}
	FCtemplates["creative progress"]["wheat farm"]["manual unlock"] = false
	FCtemplates["creative progress"]["wheat farm"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["windmill"] = {}
	FCtemplates["creative progress"]["windmill"]["manual unlock"] = false
	FCtemplates["creative progress"]["windmill"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["bakery"] = {}
	FCtemplates["creative progress"]["bakery"]["manual unlock"] = false 
	FCtemplates["creative progress"]["bakery"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["sheep farm"] = {}
	FCtemplates["creative progress"]["sheep farm"]["manual unlock"] = false  
	FCtemplates["creative progress"]["sheep farm"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["weaver hut"] = {}
	FCtemplates["creative progress"]["weaver hut"]["manual unlock"] = false  
	FCtemplates["creative progress"]["weaver hut"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["tailor's workshop"] = {}
	FCtemplates["creative progress"]["tailor's workshop"]["manual unlock"] = false   
	FCtemplates["creative progress"]["tailor's workshop"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["coal hut"] = {}
	FCtemplates["creative progress"]["coal hut"]["manual unlock"] = false  
	FCtemplates["creative progress"]["coal hut"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["iron smelter"] = {}
	FCtemplates["creative progress"]["iron smelter"]["manual unlock"] = false  
	FCtemplates["creative progress"]["iron smelter"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["blacksmith"] = {}
	FCtemplates["creative progress"]["blacksmith"]["manual unlock"] = false  
	FCtemplates["creative progress"]["blacksmith"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["iron mine"] = {}
	FCtemplates["creative progress"]["iron mine"]["manual unlock"] = false 
	FCtemplates["creative progress"]["iron mine"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["market"] = {}
	FCtemplates["creative progress"]["market"]["manual unlock"] = false 
	FCtemplates["creative progress"]["market"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["wooden bridge"] = {}
	FCtemplates["creative progress"]["wooden bridge"]["manual unlock"] = false  
	FCtemplates["creative progress"]["wooden bridge"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["lord manor"]={}
	FCtemplates["creative progress"]["lord manor"]["manual unlock"] = false
	FCtemplates["creative progress"]["lord manor"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["wooden keep"] = {}
	FCtemplates["creative progress"]["wooden keep"]["manual unlock"] = false
	FCtemplates["creative progress"]["wooden keep"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["monastery"] = {}
	FCtemplates["creative progress"]["monastery"]["manual unlock"] = false
	FCtemplates["creative progress"]["monastery"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["church"] = {}
	FCtemplates["creative progress"]["church"]["manual unlock"] = false
	FCtemplates["creative progress"]["church"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["rustic church"] = {}
	FCtemplates["creative progress"]["rustic church"]["manual unlock"] = false
	FCtemplates["creative progress"]["rustic church"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["stone bridge"] = {}
	FCtemplates["creative progress"]["stone bridge"]["manual unlock"] = false
	FCtemplates["creative progress"]["stone bridge"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["decorative bush"] = {}
	FCtemplates["creative progress"]["decorative bush"]["manual unlock"] = false
	FCtemplates["creative progress"]["decorative bush"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["fence"] = {}
	FCtemplates["creative progress"]["fence"]["manual unlock"] = false
	FCtemplates["creative progress"]["fence"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["road sign"] = {}
	FCtemplates["creative progress"]["road sign"]["manual unlock"] = false
	FCtemplates["creative progress"]["road sign"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["decorative tree"] = {}
	FCtemplates["creative progress"]["decorative tree"]["manual unlock"] = false 
	FCtemplates["creative progress"]["decorative tree"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["cypress"] = {}
	FCtemplates["creative progress"]["cypress"]["manual unlock"] = false
	FCtemplates["creative progress"]["cypress"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["creative progress"]["fountain"] = {}
	FCtemplates["creative progress"]["fountain"]["manual unlock"] = false
	FCtemplates["creative progress"]["fountain"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}

	f,err = io.open(cp .. "balancing config\\creative\\unlockProgress.json","wb")
	jstr = json.encode (FCtemplates["creative progress"], { indent = true }) 
	f:write(jstr)
	f:close()
	err = nil
	f = nil
else f =nil end



local f, err = io.open(cp .. "balancing config\\default\\unlockProgress.json","r")
if not err then
local str = f:read("*all")
if string.match(str, "upfront") or str=="null" then
f.close()
f=nil
fix = 1
end
end
err = nil


local f, err = io.open(cp .. "balancing config\\custom\\unlockProgress.json","r")
if not err then
local str = f:read("*all")
if string.match(str, "upfront")  or str == "null" then
f.close()
f=nil
fix = 1
end
end
err = nil


local f, erro = io.open(cp .. "balancing config\\custom\\unlockProgress.json","r")
f=nil
local f, err = io.open(cp .. "balancing config\\default\\unlockProgress.json","r")
f=nil
if err or erro or fix == 1 then

	FCtemplates["default progress"] = {}
	FCtemplates["default progress"]["lumber camp"] = {}
	FCtemplates["default progress"]["lumber camp"]["manual unlock"] = false
	FCtemplates["default progress"]["lumber camp"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["default progress"]["gathering hut"] = {}
	FCtemplates["default progress"]["gathering hut"]["manual unlock"] = false 
	FCtemplates["default progress"]["gathering hut"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["default progress"]["stonecutter camp"] = {}
	FCtemplates["default progress"]["stonecutter camp"]["manual unlock"] = false
	FCtemplates["default progress"]["stonecutter camp"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["default progress"]["sawmill"] = {}
	FCtemplates["default progress"]["sawmill"]["manual unlock"] = false
	FCtemplates["default progress"]["sawmill"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["default progress"]["warehouse"] = {}
	FCtemplates["default progress"]["warehouse"]["manual unlock"] = false 
	FCtemplates["default progress"]["warehouse"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["default progress"]["fisher's hut"] = {}
	FCtemplates["default progress"]["fisher's hut"]["manual unlock"] = true
	FCtemplates["default progress"]["fisher's hut"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["default progress"]["hunter's hut"] = {}
	FCtemplates["default progress"]["hunter's hut"]["manual unlock"] = true
	FCtemplates["default progress"]["hunter's hut"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["default progress"]["stonemason hut"] = {}
	FCtemplates["default progress"]["stonemason hut"]["manual unlock"] = false 
	FCtemplates["default progress"]["stonemason hut"]["requirement"] = {Status ="SERF" , Quantity = 1}
	FCtemplates["default progress"]["forester camp"] = {}
	FCtemplates["default progress"]["forester camp"]["manual unlock"] = false 
	FCtemplates["default progress"]["forester camp"]["requirement"] = {Status ="SERF" , Quantity = 12}
	FCtemplates["default progress"]["wheat farm"] = {}
	FCtemplates["default progress"]["wheat farm"]["manual unlock"] = false 
	FCtemplates["default progress"]["wheat farm"]["requirement"] = {Status ="COMMONER" , Quantity = 1}
	FCtemplates["default progress"]["windmill"] = {}
	FCtemplates["default progress"]["windmill"]["manual unlock"] = false
	FCtemplates["default progress"]["windmill"]["requirement"] = {Status ="COMMONER" , Quantity = 1}
	FCtemplates["default progress"]["bakery"] = {}
	FCtemplates["default progress"]["bakery"]["manual unlock"] = false
	FCtemplates["default progress"]["bakery"]["requirement"] = {Status ="COMMONER" , Quantity = 1}
	FCtemplates["default progress"]["sheep farm"] = {}
	FCtemplates["default progress"]["sheep farm"]["manual unlock"] = false
	FCtemplates["default progress"]["sheep farm"]["requirement"] = {Status ="COMMONER" , Quantity = 5}
	FCtemplates["default progress"]["weaver hut"] = {}
	FCtemplates["default progress"]["weaver hut"]["manual unlock"] = false
	FCtemplates["default progress"]["weaver hut"]["requirement"] = {Status ="COMMONER" , Quantity = 5}
	FCtemplates["default progress"]["tailor's workshop"] = {}
	FCtemplates["default progress"]["tailor's workshop"]["manual unlock"] = false
	FCtemplates["default progress"]["tailor's workshop"]["requirement"] = {Status ="COMMONER" , Quantity = 5}
	FCtemplates["default progress"]["coal hut"] = {}
	FCtemplates["default progress"]["coal hut"]["manual unlock"] = false 
	FCtemplates["default progress"]["coal hut"]["requirement"] = {Status ="COMMONER" , Quantity = 20}
	FCtemplates["default progress"]["iron smelter"] = {}
	FCtemplates["default progress"]["iron smelter"]["manual unlock"] = false 
	FCtemplates["default progress"]["iron smelter"]["requirement"] = {Status ="COMMONER" , Quantity = 20}
	FCtemplates["default progress"]["blacksmith"] = {}
	FCtemplates["default progress"]["blacksmith"]["manual unlock"] = false  
	FCtemplates["default progress"]["blacksmith"]["requirement"] = {Status ="COMMONER" , Quantity = 20}
	FCtemplates["default progress"]["iron mine"] = {}
	FCtemplates["default progress"]["iron mine"]["manual unlock"] = false  
	FCtemplates["default progress"]["iron mine"]["requirement"] = {Status ="COMMONER" , Quantity = 20}
	FCtemplates["default progress"]["market"] = {}
	FCtemplates["default progress"]["market"]["manual unlock"] = false  
	FCtemplates["default progress"]["market"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["default progress"]["wooden bridge"] = {}
	FCtemplates["default progress"]["wooden bridge"]["manual unlock"] = false  
	FCtemplates["default progress"]["wooden bridge"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["default progress"]["lord manor"]={}
	FCtemplates["default progress"]["lord manor"]["manual unlock"] = true
	FCtemplates["default progress"]["lord manor"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["default progress"]["wooden keep"] = {}
	FCtemplates["default progress"]["wooden keep"]["manual unlock"] = true
	FCtemplates["default progress"]["wooden keep"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["default progress"]["monastery"] = {}
	FCtemplates["default progress"]["monastery"]["manual unlock"]= true
	FCtemplates["default progress"]["monastery"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["default progress"]["church"] = {}
	FCtemplates["default progress"]["church"]["manual unlock"]= true
	FCtemplates["default progress"]["church"]["requirement"] = {Status ="NEWCOMER" , Quantity = 0}
	FCtemplates["default progress"]["rustic church"] = {}
	FCtemplates["default progress"]["rustic church"]["manual unlock"] = false  
	FCtemplates["default progress"]["rustic church"]["requirement"] = {Status ="SERF" , Quantity = 1}
	FCtemplates["default progress"]["stone bridge"] = {}
	FCtemplates["default progress"]["stone bridge"]["manual unlock"] = false  
	FCtemplates["default progress"]["stone bridge"]["requirement"] = {Status ="CITIZEN" , Quantity = 8}
	FCtemplates["default progress"]["decorative bush"] = {}
	FCtemplates["default progress"]["decorative bush"]["manual unlock"] = false  
	FCtemplates["default progress"]["decorative bush"]["requirement"] = {Status ="SERF" , Quantity = 1}
	FCtemplates["default progress"]["fence"] = {}
	FCtemplates["default progress"]["fence"]["manual unlock"] = false 
	FCtemplates["default progress"]["fence"]["requirement"] = {Status ="SERF" , Quantity = 1}
	FCtemplates["default progress"]["road sign"] = {}
	FCtemplates["default progress"]["road sign"]["manual unlock"] = false 
	FCtemplates["default progress"]["road sign"]["requirement"] = {Status ="COMMONER" , Quantity = 1}
	FCtemplates["default progress"]["decorative tree"] = {}
	FCtemplates["default progress"]["decorative tree"]["manual unlock"] = false 
	FCtemplates["default progress"]["decorative tree"]["requirement"] = {Status ="COMMONER" , Quantity = 6}
	FCtemplates["default progress"]["cypress"] = {}
	FCtemplates["default progress"]["cypress"]["manual unlock"] = false 
	FCtemplates["default progress"]["cypress"]["requirement"] = {Status ="CITIZEN" , Quantity = 10}
	FCtemplates["default progress"]["fountain"] = {}
	FCtemplates["default progress"]["fountain"]["manual unlock"] = false 
	FCtemplates["default progress"]["fountain"]["requirement"] = {Status ="CITIZEN" , Quantity = 10}

	if err or fix == 1 then
		err = nil 
		local f,err = io.open(cp .. "balancing config\\default\\unlockProgress.json","wb")
		jstr = json.encode (FCtemplates["default progress"], { indent = true }) 
		f:write(jstr)
		f:close()
		err = nil
		f = nil
	end
	if erro or fix == 1 then
		erro = nil
		local f,erro = io.open(cp .. "balancing config\\custom\\unlockProgress.json","wb")
		jstr = json.encode (FCtemplates["default progress"], { indent = true }) 
		f:write(jstr)
		f:close()
		err = nil
		f = nil
	end
end



local f, error = io.open(cp .. "balancing config\\creative\\tradingVillages.json","r")
f = nil
local f, erro = io.open(cp .. "balancing config\\custom\\tradingVillages.json","r")
f=nil
local f, err = io.open(cp .. "balancing config\\default\\tradingVillages.json","r")
f = nil
if err or erro then

	FCtemplates["tradingVillages"] = {}
	FCtemplates["tradingVillages"]["Davenport"] = {}
	FCtemplates["tradingVillages"]["Davenport"] ["unlock cost"] = {{ Resource = "PLANK", Quantity = 20 }}
	FCtemplates["tradingVillages"]["Davenport"]["estate"] = "KINGDOM"
	FCtemplates["tradingVillages"]["Davenport"]["is selling"] = {

		{
			ResourceMaxAmount = { Resource = "TOOL", Quantity = 100 },
			UnitPrice = { Resource = "GOLD", Quantity = 10 }	
		},

		{
			ResourceMaxAmount = { Resource = "BREAD", Quantity = 50 },
			UnitPrice = { Resource = "GOLD", Quantity = 10 }	
		},

		{
			ResourceMaxAmount = { Resource = "FISH", Quantity = 50 },
			UnitPrice = { Resource = "GOLD", Quantity = 7 }	
		}
	}
	FCtemplates["tradingVillages"]["Davenport"]["is buying"] = {

		{
			ResourceMaxAmount = { Resource = "BERRIES", Quantity = 50 },
			UnitPrice = { Resource = "GOLD", Quantity = 2 }	
		},

		{
			ResourceMaxAmount = { Resource = "POLISHED_STONE", Quantity = 50 },
			UnitPrice = { Resource = "GOLD", Quantity = 3 }	
		},

		{
			ResourceMaxAmount = { Resource = "PLANK", Quantity = 50 },
			UnitPrice = { Resource = "GOLD", Quantity = 2 }	
		}

	}

	FCtemplates["tradingVillages"]["Northbury"] = {}
	FCtemplates["tradingVillages"]["Northbury"]["unlock cost"] = {{ Resource = "BREAD", Quantity = 20 }}
	FCtemplates["tradingVillages"]["Northbury"]["estate"] = "CLERGY"
	FCtemplates["tradingVillages"]["Northbury"]["is selling"] = {

		{
			ResourceMaxAmount = { Resource = "COAL", Quantity = 20 },
			UnitPrice = { Resource = "GOLD", Quantity = 5 }	
		},

		{
			ResourceMaxAmount = { Resource = "IRON", Quantity = 20 },
			UnitPrice = { Resource = "GOLD", Quantity = 20 }	
		},

		{
			ResourceMaxAmount = { Resource = "GLASS", Quantity = 10 },
			UnitPrice = { Resource = "GOLD", Quantity = 50 }	
		}
	}
	FCtemplates["tradingVillages"]["Northbury"]["is buying"] = {

		{
			ResourceMaxAmount = { Resource = "WOOL", Quantity = 10 },
			UnitPrice = { Resource = "GOLD", Quantity = 5 }	
		},

		{
			ResourceMaxAmount = { Resource = "CLOTHES", Quantity = 10 },
			UnitPrice = { Resource = "GOLD", Quantity = 10 }	
		},

		{
			ResourceMaxAmount = { Resource = "LEATHER", Quantity = 10 },
			UnitPrice = { Resource = "GOLD", Quantity = 15 }	
		},

		{
			ResourceMaxAmount = { Resource = "HERBS", Quantity = 10 },
			UnitPrice = { Resource = "GOLD", Quantity = 20 }	
		}

	}
	FCtemplates["tradingVillages"]["Myddle"] = {}
	FCtemplates["tradingVillages"]["Myddle"]["unlock cost"] = {{ Resource = "GOLD", Quantity = 1000 }}
	FCtemplates["tradingVillages"]["Myddle"]["estate"] = "CLERGY"
	FCtemplates["tradingVillages"]["Myddle"]["is selling"] = {

		{
			ResourceMaxAmount = { Resource = "WOOL", Quantity = 20 },
			UnitPrice = { Resource = "GOLD", Quantity = 2 }	
		},

		{
			ResourceMaxAmount = { Resource = "WINE", Quantity = 20 },
			UnitPrice = { Resource = "GOLD", Quantity = 60 }	
		},

		{
			ResourceMaxAmount = { Resource = "TOOL", Quantity = 10 },
			UnitPrice = { Resource = "GOLD", Quantity = 40 }	
		}
	}
	FCtemplates["tradingVillages"]["Myddle"]["is buying"] = {

		{
			ResourceMaxAmount = { Resource = "FISH", Quantity = 10 },
			UnitPrice = { Resource = "GOLD", Quantity = 5 }	
		},

		{
			ResourceMaxAmount = { Resource = "HONEY", Quantity = 10 },
			UnitPrice = { Resource = "GOLD", Quantity = 30 }	
		},

		{
			ResourceMaxAmount = { Resource = "WEAPON", Quantity = 10 },
			UnitPrice = { Resource = "GOLD", Quantity = 50 }	
		}

	}

	if err then
		err = nil
		local f,err = io.open(cp .. "balancing config\\default\\tradingVillages.json","wb")
		jstr = json.encode (FCtemplates["tradingVillages"] , { indent = true }) 
		f:write(jstr)
		f:close()
		err = nil
		f = nil
	end
	if error then
		err = nil
		local f,err = io.open(cp .. "balancing config\\creative\\tradingVillages.json","wb")
		jstr = json.encode (FCtemplates["tradingVillages"] , { indent = true }) 
		f:write(jstr)
		f:close()
		err = nil
		f = nil
	end
	if erro then
		erro = nil
		local f,erro = io.open(cp .. "balancing config\\custom\\tradingVillages.json","wb")
		jstr = json.encode (FCtemplates["tradingVillages"] , { indent = true }) 
		f:write(jstr)
		f:close()
		err = nil
		f = nil
	end
end


local f, erro = io.open(cp .. "estateList.txt","r")
f=nil
local f, err = io.open(cp .. "resourceList.txt","r")
f = nil
if err or erro then
	if err then
		err = nil
		local f,err = io.open(cp .. "resourceList.txt","wb") 
		f:write('"BERRIES"\n"BREAD"\n"CLOTHES"\n"COAL"\n"DEER"\n"FAITH"\n"FISH"\n"FLOUR"\n"GLASS"\n"GOLD"\n"HERBS"\n"HONEY"\n"IRON"\n"IRON_ORE"\n"LEATHER"\n"PLANK"\n"POLISHED_STONE"\n"STONE"\n"TOOL"\n"WATER"\n"WEAPON"\n"WHEAT"\n"WINE"\n"WOOD"\n"WOOL"\n"WOOLEN_CLOTH"')
		f:close()
		err = nil
		f = nil
	end
	if erro then
		erro = nil
		local f,erro = io.open(cp .. "estateList.txt","wb")
		f:write('"CLERGY"\n"KINGDOM"\n"LABOUR"')
		f:close()
		err = nil
		f = nil
	end
end