local FC = ...
local FCtemplates = {}
local hp = os.getenv("HOMEPATH")
local mp = hp .. "\\Documents\\Polymorph Games\\Foundation\\mods\\500\\"
local cp = hp .. "\\Documents\\Polymorph Games\\Foundation\\mods\\Fiery Essential\\"

local json = require ("dkjson")
local jstr = ""



	local FCconfigu = {["main"]={}}

	local f = io.open(cp .. "mainConfig.json","r")
	FCconfigu["main"] = json.decode(f:read("*all"))
	f.close()

if FCconfigu["main"]["config version"] == "0.1" then
	FCconfigu["creative"]={}
	FCconfigu["default"]={}
	FCconfigu["custom"]={}
	
	f = io.open(cp .. "\\balancing config\\creative\\unlockProgress.json","r")
	FCconfigu["creative"] = json.decode(f:read("*all"))
	f.close()
	f = io.open(cp .. "\\balancing config\\default\\unlockProgress.json","r")
	FCconfigu["default"] = json.decode(f:read("*all"))
	f.close()
	f = io.open(cp .. "\\balancing config\\custom\\unlockProgress.json","r")
	FCconfigu["custom"] = json.decode(f:read("*all"))
	f.close()

	FCtemplates["main"]={}
	FCtemplates["main"]["config version"] = "0.2"
	FCtemplates["main"]["balance mode"] = FCconfigu["main"]["balance mode"]
	FCtemplates["main"]["more villager names"] = FCconfigu["main"]["more villager names"] 
	FCtemplates["main"]["enable welcome event"] = FCconfigu["main"]["enable welcome event"]

	local f,err = io.open(cp .. "mainConfig.json","wb")
	jstr = json.encode (FCtemplates["main"], { indent = true })
	f:write(jstr)
	f:close()
	f = nil
	err = nil

	FCtemplates["creative progress"] = {}
	FCtemplates["creative progress"]["lumber camp"] ={}
	FCtemplates["creative progress"]["lumber camp"]["manual unlock"] = false
	FCtemplates["creative progress"]["lumber camp"]["requirement"] = FCconfigu["creative"]["lumber camp"]
	FCtemplates["creative progress"]["gathering hut"] = {}
	FCtemplates["creative progress"]["gathering hut"]["manual unlock"] = false
	FCtemplates["creative progress"]["gathering hut"]["requirement"] = FCconfigu["creative"]["gathering hut"]
	FCtemplates["creative progress"]["stonecutter camp"] = {}
	FCtemplates["creative progress"]["stonecutter camp"]["manual unlock"] = false
	FCtemplates["creative progress"]["stonecutter camp"]["requirement"] = FCconfigu["creative"]["stonecutter camp"]
	FCtemplates["creative progress"]["sawmill"] = {}
	FCtemplates["creative progress"]["sawmill"]["manual unlock"] = false
	FCtemplates["creative progress"]["sawmill"]["requirement"] = FCconfigu["creative"]["sawmill"]
	FCtemplates["creative progress"]["warehouse"] ={}
	FCtemplates["creative progress"]["warehouse"]["manual unlock"] = false
	FCtemplates["creative progress"]["warehouse"]["requirement"] = FCconfigu["creative"]["warehouse"]
	FCtemplates["creative progress"]["fisher's hut"] = {}
	FCtemplates["creative progress"]["fisher's hut"]["manual unlock"] =FCconfigu["creative"]["fisher's hut"]["manual unlock"]
	FCtemplates["creative progress"]["fisher's hut"]["requirement"] = FCconfigu["creative"]["fisher's hut"]["requirement"]
	FCtemplates["creative progress"]["hunter's hut"] = {}
	FCtemplates["creative progress"]["hunter's hut"]["manual unlock"] = FCconfigu["creative"]["hunter's hut"]["manual unlock"]
	FCtemplates["creative progress"]["hunter's hut"]["requirement"] =FCconfigu["creative"]["hunter's hut"]["requirement"]
	FCtemplates["creative progress"]["stonemason hut"] = {}
	FCtemplates["creative progress"]["stonemason hut"]["manual unlock"] = false
	FCtemplates["creative progress"]["stonemason hut"]["requirement"] = FCconfigu["creative"]["stonemason hut"]
	FCtemplates["creative progress"]["forester camp"] = {}
	FCtemplates["creative progress"]["forester camp"]["manual unlock"] = false
	FCtemplates["creative progress"]["forester camp"]["requirement"] = FCconfigu["creative"]["forester camp"]
	FCtemplates["creative progress"]["wheat farm"] = {}
	FCtemplates["creative progress"]["wheat farm"]["manual unlock"] = false
	FCtemplates["creative progress"]["wheat farm"]["requirement"] =FCconfigu["creative"]["wheat farm"]
	FCtemplates["creative progress"]["windmill"] = {}
	FCtemplates["creative progress"]["windmill"]["manual unlock"] = false
	FCtemplates["creative progress"]["windmill"]["requirement"] = FCconfigu["creative"]["windmill"]
	FCtemplates["creative progress"]["bakery"] = {}
	FCtemplates["creative progress"]["bakery"]["manual unlock"] = false 
	FCtemplates["creative progress"]["bakery"]["requirement"] = FCconfigu["creative"]["bakery"]
	FCtemplates["creative progress"]["sheep farm"] = {}
	FCtemplates["creative progress"]["sheep farm"]["manual unlock"] = false  
	FCtemplates["creative progress"]["sheep farm"]["requirement"] = FCconfigu["creative"]["sheep farm"]
	FCtemplates["creative progress"]["weaver hut"] = {}
	FCtemplates["creative progress"]["weaver hut"]["manual unlock"] = false  
	FCtemplates["creative progress"]["weaver hut"]["requirement"] = FCconfigu["creative"]["weaver hut"]
	FCtemplates["creative progress"]["tailor's workshop"] = {}
	FCtemplates["creative progress"]["tailor's workshop"]["manual unlock"] = false   
	FCtemplates["creative progress"]["tailor's workshop"]["requirement"] = FCconfigu["creative"]["tailor's workshop"]
	FCtemplates["creative progress"]["coal hut"] = {}
	FCtemplates["creative progress"]["coal hut"]["manual unlock"] = false  
	FCtemplates["creative progress"]["coal hut"]["requirement"] = FCconfigu["creative"]["coal hut"]
	FCtemplates["creative progress"]["iron smelter"] = {}
	FCtemplates["creative progress"]["iron smelter"]["manual unlock"] = false  
	FCtemplates["creative progress"]["iron smelter"]["requirement"] = FCconfigu["creative"]["iron smelter"]
	FCtemplates["creative progress"]["blacksmith"] = {}
	FCtemplates["creative progress"]["blacksmith"]["manual unlock"] = false  
	FCtemplates["creative progress"]["blacksmith"]["requirement"] = FCconfigu["creative"]["blacksmith"]
	FCtemplates["creative progress"]["iron mine"] = {}
	FCtemplates["creative progress"]["iron mine"]["manual unlock"] = false 
	FCtemplates["creative progress"]["iron mine"]["requirement"] = FCconfigu["creative"]["iron mine"]
	FCtemplates["creative progress"]["market"] = {}
	FCtemplates["creative progress"]["market"]["manual unlock"] = false 
	FCtemplates["creative progress"]["market"]["requirement"] = FCconfigu["creative"]["market"]
	FCtemplates["creative progress"]["wooden bridge"] = {}
	FCtemplates["creative progress"]["wooden bridge"]["manual unlock"] = false  
	FCtemplates["creative progress"]["wooden bridge"]["requirement"] = FCconfigu["creative"]["wooden bridge"]
	FCtemplates["creative progress"]["lord manor"]={}
	FCtemplates["creative progress"]["lord manor"]["manual unlock"] = FCconfigu["creative"]["lord manor"]["manual unlock"]
	FCtemplates["creative progress"]["lord manor"]["requirement"] = FCconfigu["creative"]["lord manor"]["requirement"]
	FCtemplates["creative progress"]["wooden keep"] = {}
	FCtemplates["creative progress"]["wooden keep"]["manual unlock"] = FCconfigu["creative"]["wooden keep"]["manual unlock"]
	FCtemplates["creative progress"]["wooden keep"]["requirement"] = FCconfigu["creative"]["wooden keep"]["requirement"]
	FCtemplates["creative progress"]["monastery"] = {}
	FCtemplates["creative progress"]["monastery"]["manual unlock"] = FCconfigu["creative"]["monastery"]["manual unlock"]
	FCtemplates["creative progress"]["monastery"]["requirement"] = FCconfigu["creative"]["monastery"]["requirement"]
	FCtemplates["creative progress"]["church"] = {}
	FCtemplates["creative progress"]["church"]["manual unlock"] = FCconfigu["creative"]["church"]["manual unlock"]
	FCtemplates["creative progress"]["church"]["requirement"] = FCconfigu["creative"]["church"]["requirement"]
	FCtemplates["creative progress"]["rustic church"] = {}
	FCtemplates["creative progress"]["rustic church"]["manual unlock"] = false
	FCtemplates["creative progress"]["rustic church"]["requirement"] = FCconfigu["creative"]["rustic church"]
	FCtemplates["creative progress"]["stone bridge"] = {}
	FCtemplates["creative progress"]["stone bridge"]["manual unlock"] = false
	FCtemplates["creative progress"]["stone bridge"]["requirement"] = FCconfigu["creative"]["stone bridge"]
	FCtemplates["creative progress"]["decorative bush"] = {}
	FCtemplates["creative progress"]["decorative bush"]["manual unlock"] = false
	FCtemplates["creative progress"]["decorative bush"]["requirement"] = FCconfigu["creative"]["decorative bush"]
	FCtemplates["creative progress"]["fence"] = {}
	FCtemplates["creative progress"]["fence"]["manual unlock"] = false
	FCtemplates["creative progress"]["fence"]["requirement"] = FCconfigu["creative"]["fence"]
	FCtemplates["creative progress"]["road sign"] = {}
	FCtemplates["creative progress"]["road sign"]["manual unlock"] = false
	FCtemplates["creative progress"]["road sign"]["requirement"] = FCconfigu["creative"]["road sign"]
	FCtemplates["creative progress"]["decorative tree"] = {}
	FCtemplates["creative progress"]["decorative tree"]["manual unlock"] = false 
	FCtemplates["creative progress"]["decorative tree"]["requirement"] = FCconfigu["creative"]["decorative tree"]
	FCtemplates["creative progress"]["cypress"] = {}
	FCtemplates["creative progress"]["cypress"]["manual unlock"] = false
	FCtemplates["creative progress"]["cypress"]["requirement"] = FCconfigu["creative"]["cypress"]
	FCtemplates["creative progress"]["fountain"] = {}
	FCtemplates["creative progress"]["fountain"]["manual unlock"] = false
	FCtemplates["creative progress"]["fountain"]["requirement"] = FCconfigu["creative"]["fountain"]

	f,err = io.open(cp .. "balancing config\\creative\\unlockProgress.json","wb")
	jstr = json.encode (FCtemplates["creative progress"], { indent = true }) 
	f:write(jstr)
	f:close()
	f= nil
	err = nil


	if FCconfigu["default"]["lumber camp"]["manual unlock"] == nil then
	FCtemplates["default progress"] = {}
	FCtemplates["default progress"]["lumber camp"] ={}
	FCtemplates["default progress"]["lumber camp"]["manual unlock"] = false
	FCtemplates["default progress"]["lumber camp"]["requirement"] = FCconfigu["default"]["lumber camp"]
	FCtemplates["default progress"]["gathering hut"] = {}
	FCtemplates["default progress"]["gathering hut"]["manual unlock"] = false
	FCtemplates["default progress"]["gathering hut"]["requirement"] = FCconfigu["default"]["gathering hut"]
	FCtemplates["default progress"]["stonecutter camp"] = {}
	FCtemplates["default progress"]["stonecutter camp"]["manual unlock"] = false
	FCtemplates["default progress"]["stonecutter camp"]["requirement"] = FCconfigu["default"]["stonecutter camp"]
	FCtemplates["default progress"]["sawmill"] = {}
	FCtemplates["default progress"]["sawmill"]["manual unlock"] = false
	FCtemplates["default progress"]["sawmill"]["requirement"] = FCconfigu["default"]["sawmill"]
	FCtemplates["default progress"]["warehouse"] ={}
	FCtemplates["default progress"]["warehouse"]["manual unlock"] = false
	FCtemplates["default progress"]["warehouse"]["requirement"] = FCconfigu["default"]["warehouse"]
	FCtemplates["default progress"]["fisher's hut"] = {}
	FCtemplates["default progress"]["fisher's hut"]["manual unlock"] =FCconfigu["default"]["fisher's hut"]["manual unlock"]
	FCtemplates["default progress"]["fisher's hut"]["requirement"] = FCconfigu["default"]["fisher's hut"]["requirement"]
	FCtemplates["default progress"]["hunter's hut"] = {}
	FCtemplates["default progress"]["hunter's hut"]["manual unlock"] = FCconfigu["default"]["hunter's hut"]["manual unlock"]
	FCtemplates["default progress"]["hunter's hut"]["requirement"] =FCconfigu["default"]["hunter's hut"]["requirement"]
	FCtemplates["default progress"]["stonemason hut"] = {}
	FCtemplates["default progress"]["stonemason hut"]["manual unlock"] = false
	FCtemplates["default progress"]["stonemason hut"]["requirement"] = FCconfigu["default"]["stonemason hut"]
	FCtemplates["default progress"]["forester camp"] = {}
	FCtemplates["default progress"]["forester camp"]["manual unlock"] = false
	FCtemplates["default progress"]["forester camp"]["requirement"] = FCconfigu["default"]["forester camp"]
	FCtemplates["default progress"]["wheat farm"] = {}
	FCtemplates["default progress"]["wheat farm"]["manual unlock"] = false
	FCtemplates["default progress"]["wheat farm"]["requirement"] =FCconfigu["default"]["wheat farm"]
	FCtemplates["default progress"]["windmill"] = {}
	FCtemplates["default progress"]["windmill"]["manual unlock"] = false
	FCtemplates["default progress"]["windmill"]["requirement"] = FCconfigu["default"]["windmill"]
	FCtemplates["default progress"]["bakery"] = {}
	FCtemplates["default progress"]["bakery"]["manual unlock"] = false 
	FCtemplates["default progress"]["bakery"]["requirement"] = FCconfigu["default"]["bakery"]
	FCtemplates["default progress"]["sheep farm"] = {}
	FCtemplates["default progress"]["sheep farm"]["manual unlock"] = false  
	FCtemplates["default progress"]["sheep farm"]["requirement"] = FCconfigu["default"]["sheep farm"]
	FCtemplates["default progress"]["weaver hut"] = {}
	FCtemplates["default progress"]["weaver hut"]["manual unlock"] = false  
	FCtemplates["default progress"]["weaver hut"]["requirement"] = FCconfigu["default"]["weaver hut"]
	FCtemplates["default progress"]["tailor's workshop"] = {}
	FCtemplates["default progress"]["tailor's workshop"]["manual unlock"] = false   
	FCtemplates["default progress"]["tailor's workshop"]["requirement"] = FCconfigu["default"]["tailor's workshop"]
	FCtemplates["default progress"]["coal hut"] = {}
	FCtemplates["default progress"]["coal hut"]["manual unlock"] = false  
	FCtemplates["default progress"]["coal hut"]["requirement"] = FCconfigu["default"]["coal hut"]
	FCtemplates["default progress"]["iron smelter"] = {}
	FCtemplates["default progress"]["iron smelter"]["manual unlock"] = false  
	FCtemplates["default progress"]["iron smelter"]["requirement"] = FCconfigu["default"]["iron smelter"]
	FCtemplates["default progress"]["blacksmith"] = {}
	FCtemplates["default progress"]["blacksmith"]["manual unlock"] = false  
	FCtemplates["default progress"]["blacksmith"]["requirement"] = FCconfigu["default"]["blacksmith"]
	FCtemplates["default progress"]["iron mine"] = {}
	FCtemplates["default progress"]["iron mine"]["manual unlock"] = false 
	FCtemplates["default progress"]["iron mine"]["requirement"] = FCconfigu["default"]["iron mine"]
	FCtemplates["default progress"]["market"] = {}
	FCtemplates["default progress"]["market"]["manual unlock"] = false 
	FCtemplates["default progress"]["market"]["requirement"] = FCconfigu["default"]["market"]
	FCtemplates["default progress"]["wooden bridge"] = {}
	FCtemplates["default progress"]["wooden bridge"]["manual unlock"] = false  
	FCtemplates["default progress"]["wooden bridge"]["requirement"] = FCconfigu["default"]["wooden bridge"]
	FCtemplates["default progress"]["lord manor"]={}
	FCtemplates["default progress"]["lord manor"]["manual unlock"] = FCconfigu["default"]["lord manor"]["manual unlock"]
	FCtemplates["default progress"]["lord manor"]["requirement"] = FCconfigu["default"]["lord manor"]["requirement"]
	FCtemplates["default progress"]["wooden keep"] = {}
	FCtemplates["default progress"]["wooden keep"]["manual unlock"] = FCconfigu["default"]["wooden keep"]["manual unlock"]
	FCtemplates["default progress"]["wooden keep"]["requirement"] = FCconfigu["default"]["wooden keep"]["requirement"]
	FCtemplates["default progress"]["monastery"] = {}
	FCtemplates["default progress"]["monastery"]["manual unlock"] = FCconfigu["default"]["monastery"]["manual unlock"]
	FCtemplates["default progress"]["monastery"]["requirement"] = FCconfigu["default"]["monastery"]["requirement"]
	FCtemplates["default progress"]["church"] = {}
	FCtemplates["default progress"]["church"]["manual unlock"] = FCconfigu["default"]["church"]["manual unlock"]
	FCtemplates["default progress"]["church"]["requirement"] = FCconfigu["default"]["church"]["requirement"]
	FCtemplates["default progress"]["rustic church"] = {}
	FCtemplates["default progress"]["rustic church"]["manual unlock"] = false
	FCtemplates["default progress"]["rustic church"]["requirement"] = FCconfigu["default"]["rustic church"]
	FCtemplates["default progress"]["stone bridge"] = {}
	FCtemplates["default progress"]["stone bridge"]["manual unlock"] = false
	FCtemplates["default progress"]["stone bridge"]["requirement"] = FCconfigu["default"]["stone bridge"]
	FCtemplates["default progress"]["decorative bush"] = {}
	FCtemplates["default progress"]["decorative bush"]["manual unlock"] = false
	FCtemplates["default progress"]["decorative bush"]["requirement"] = FCconfigu["default"]["decorative bush"]
	FCtemplates["default progress"]["fence"] = {}
	FCtemplates["default progress"]["fence"]["manual unlock"] = false
	FCtemplates["default progress"]["fence"]["requirement"] = FCconfigu["default"]["fence"]
	FCtemplates["default progress"]["road sign"] = {}
	FCtemplates["default progress"]["road sign"]["manual unlock"] = false
	FCtemplates["default progress"]["road sign"]["requirement"] = FCconfigu["default"]["road sign"]
	FCtemplates["default progress"]["decorative tree"] = {}
	FCtemplates["default progress"]["decorative tree"]["manual unlock"] = false 
	FCtemplates["default progress"]["decorative tree"]["requirement"] = FCconfigu["default"]["decorative tree"]
	FCtemplates["default progress"]["cypress"] = {}
	FCtemplates["default progress"]["cypress"]["manual unlock"] = false
	FCtemplates["default progress"]["cypress"]["requirement"] = FCconfigu["default"]["cypress"]
	FCtemplates["default progress"]["fountain"] = {}
	FCtemplates["default progress"]["fountain"]["manual unlock"] = false
	FCtemplates["default progress"]["fountain"]["requirement"] = FCconfigu["default"]["fountain"]

	f,err = io.open(cp .. "balancing config\\default\\unlockProgress.json","wb")
	jstr = json.encode (FCtemplates["default progress"], { indent = true }) 
	f:write(jstr)
	f:close()
	f= nil
	err = nil
	end

	
	if FCconfigu["custom"]["lumber camp"]["manual unlock"] == nil then
	FCtemplates["custom progress"] = {}
	FCtemplates["custom progress"]["lumber camp"] ={}
	FCtemplates["custom progress"]["lumber camp"]["manual unlock"] = false
	FCtemplates["custom progress"]["lumber camp"]["requirement"] = FCconfigu["custom"]["lumber camp"]
	FCtemplates["custom progress"]["gathering hut"] = {}
	FCtemplates["custom progress"]["gathering hut"]["manual unlock"] = false
	FCtemplates["custom progress"]["gathering hut"]["requirement"] = FCconfigu["custom"]["gathering hut"]
	FCtemplates["custom progress"]["stonecutter camp"] = {}
	FCtemplates["custom progress"]["stonecutter camp"]["manual unlock"] = false
	FCtemplates["custom progress"]["stonecutter camp"]["requirement"] = FCconfigu["custom"]["stonecutter camp"]
	FCtemplates["custom progress"]["sawmill"] = {}
	FCtemplates["custom progress"]["sawmill"]["manual unlock"] = false
	FCtemplates["custom progress"]["sawmill"]["requirement"] = FCconfigu["custom"]["sawmill"]
	FCtemplates["custom progress"]["warehouse"] ={}
	FCtemplates["custom progress"]["warehouse"]["manual unlock"] = false
	FCtemplates["custom progress"]["warehouse"]["requirement"] = FCconfigu["custom"]["warehouse"]
	FCtemplates["custom progress"]["fisher's hut"] = {}
	FCtemplates["custom progress"]["fisher's hut"]["manual unlock"] =FCconfigu["custom"]["fisher's hut"]["manual unlock"]
	FCtemplates["custom progress"]["fisher's hut"]["requirement"] = FCconfigu["custom"]["fisher's hut"]["requirement"]
	FCtemplates["custom progress"]["hunter's hut"] = {}
	FCtemplates["custom progress"]["hunter's hut"]["manual unlock"] = FCconfigu["custom"]["hunter's hut"]["manual unlock"]
	FCtemplates["custom progress"]["hunter's hut"]["requirement"] =FCconfigu["custom"]["hunter's hut"]["requirement"]
	FCtemplates["custom progress"]["stonemason hut"] = {}
	FCtemplates["custom progress"]["stonemason hut"]["manual unlock"] = false
	FCtemplates["custom progress"]["stonemason hut"]["requirement"] = FCconfigu["custom"]["stonemason hut"]
	FCtemplates["custom progress"]["forester camp"] = {}
	FCtemplates["custom progress"]["forester camp"]["manual unlock"] = false
	FCtemplates["custom progress"]["forester camp"]["requirement"] = FCconfigu["custom"]["forester camp"]
	FCtemplates["custom progress"]["wheat farm"] = {}
	FCtemplates["custom progress"]["wheat farm"]["manual unlock"] = false
	FCtemplates["custom progress"]["wheat farm"]["requirement"] =FCconfigu["custom"]["wheat farm"]
	FCtemplates["custom progress"]["windmill"] = {}
	FCtemplates["custom progress"]["windmill"]["manual unlock"] = false
	FCtemplates["custom progress"]["windmill"]["requirement"] = FCconfigu["custom"]["windmill"]
	FCtemplates["custom progress"]["bakery"] = {}
	FCtemplates["custom progress"]["bakery"]["manual unlock"] = false 
	FCtemplates["custom progress"]["bakery"]["requirement"] = FCconfigu["custom"]["bakery"]
	FCtemplates["custom progress"]["sheep farm"] = {}
	FCtemplates["custom progress"]["sheep farm"]["manual unlock"] = false  
	FCtemplates["custom progress"]["sheep farm"]["requirement"] = FCconfigu["custom"]["sheep farm"]
	FCtemplates["custom progress"]["weaver hut"] = {}
	FCtemplates["custom progress"]["weaver hut"]["manual unlock"] = false  
	FCtemplates["custom progress"]["weaver hut"]["requirement"] = FCconfigu["custom"]["weaver hut"]
	FCtemplates["custom progress"]["tailor's workshop"] = {}
	FCtemplates["custom progress"]["tailor's workshop"]["manual unlock"] = false   
	FCtemplates["custom progress"]["tailor's workshop"]["requirement"] = FCconfigu["custom"]["tailor's workshop"]
	FCtemplates["custom progress"]["coal hut"] = {}
	FCtemplates["custom progress"]["coal hut"]["manual unlock"] = false  
	FCtemplates["custom progress"]["coal hut"]["requirement"] = FCconfigu["custom"]["coal hut"]
	FCtemplates["custom progress"]["iron smelter"] = {}
	FCtemplates["custom progress"]["iron smelter"]["manual unlock"] = false  
	FCtemplates["custom progress"]["iron smelter"]["requirement"] = FCconfigu["custom"]["iron smelter"]
	FCtemplates["custom progress"]["blacksmith"] = {}
	FCtemplates["custom progress"]["blacksmith"]["manual unlock"] = false  
	FCtemplates["custom progress"]["blacksmith"]["requirement"] = FCconfigu["custom"]["blacksmith"]
	FCtemplates["custom progress"]["iron mine"] = {}
	FCtemplates["custom progress"]["iron mine"]["manual unlock"] = false 
	FCtemplates["custom progress"]["iron mine"]["requirement"] = FCconfigu["custom"]["iron mine"]
	FCtemplates["custom progress"]["market"] = {}
	FCtemplates["custom progress"]["market"]["manual unlock"] = false 
	FCtemplates["custom progress"]["market"]["requirement"] = FCconfigu["custom"]["market"]
	FCtemplates["custom progress"]["wooden bridge"] = {}
	FCtemplates["custom progress"]["wooden bridge"]["manual unlock"] = false  
	FCtemplates["custom progress"]["wooden bridge"]["requirement"] = FCconfigu["custom"]["wooden bridge"]
	FCtemplates["custom progress"]["lord manor"]={}
	FCtemplates["custom progress"]["lord manor"]["manual unlock"] = FCconfigu["custom"]["lord manor"]["manual unlock"]
	FCtemplates["custom progress"]["lord manor"]["requirement"] = FCconfigu["custom"]["lord manor"]["requirement"]
	FCtemplates["custom progress"]["wooden keep"] = {}
	FCtemplates["custom progress"]["wooden keep"]["manual unlock"] = FCconfigu["custom"]["wooden keep"]["manual unlock"]
	FCtemplates["custom progress"]["wooden keep"]["requirement"] = FCconfigu["custom"]["wooden keep"]["requirement"]
	FCtemplates["custom progress"]["monastery"] = {}
	FCtemplates["custom progress"]["monastery"]["manual unlock"] = FCconfigu["custom"]["monastery"]["manual unlock"]
	FCtemplates["custom progress"]["monastery"]["requirement"] = FCconfigu["custom"]["monastery"]["requirement"]
	FCtemplates["custom progress"]["church"] = {}
	FCtemplates["custom progress"]["church"]["manual unlock"] = FCconfigu["custom"]["church"]["manual unlock"]
	FCtemplates["custom progress"]["church"]["requirement"] = FCconfigu["custom"]["church"]["requirement"]
	FCtemplates["custom progress"]["rustic church"] = {}
	FCtemplates["custom progress"]["rustic church"]["manual unlock"] = false
	FCtemplates["custom progress"]["rustic church"]["requirement"] = FCconfigu["custom"]["rustic church"]
	FCtemplates["custom progress"]["stone bridge"] = {}
	FCtemplates["custom progress"]["stone bridge"]["manual unlock"] = false
	FCtemplates["custom progress"]["stone bridge"]["requirement"] = FCconfigu["custom"]["stone bridge"]
	FCtemplates["custom progress"]["decorative bush"] = {}
	FCtemplates["custom progress"]["decorative bush"]["manual unlock"] = false
	FCtemplates["custom progress"]["decorative bush"]["requirement"] = FCconfigu["custom"]["decorative bush"]
	FCtemplates["custom progress"]["fence"] = {}
	FCtemplates["custom progress"]["fence"]["manual unlock"] = false
	FCtemplates["custom progress"]["fence"]["requirement"] = FCconfigu["custom"]["fence"]
	FCtemplates["custom progress"]["road sign"] = {}
	FCtemplates["custom progress"]["road sign"]["manual unlock"] = false
	FCtemplates["custom progress"]["road sign"]["requirement"] = FCconfigu["custom"]["road sign"]
	FCtemplates["custom progress"]["decorative tree"] = {}
	FCtemplates["custom progress"]["decorative tree"]["manual unlock"] = false 
	FCtemplates["custom progress"]["decorative tree"]["requirement"] = FCconfigu["custom"]["decorative tree"]
	FCtemplates["custom progress"]["cypress"] = {}
	FCtemplates["custom progress"]["cypress"]["manual unlock"] = false
	FCtemplates["custom progress"]["cypress"]["requirement"] = FCconfigu["custom"]["cypress"]
	FCtemplates["custom progress"]["fountain"] = {}
	FCtemplates["custom progress"]["fountain"]["manual unlock"] = false
	FCtemplates["custom progress"]["fountain"]["requirement"] = FCconfigu["custom"]["fountain"]

	f,err = io.open(cp .. "balancing config\\custom\\unlockProgress.json","wb")
	jstr = json.encode (FCtemplates["custom progress"], { indent = true }) 
	f:write(jstr)
	f:close()
	f= nil
	err = nil
	end



	FCconfigu = nil
end

